package de.mdelab.instanceGraphEditor.ui.commands;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.commands.Command;

import de.mdelab.instanceGraphEditor.ui.figures.NodeFigure;
import de.mdelab.instanceGraphEditor.ui.model.Node;

public class NodeAttributeValueEditCommand extends Command{
	
	private Node model;
	private String oldValue, newValue;
	private String attributeName;
	
	@Override
	public void execute() {
		EAttribute attr = model.getAttributeByName(attributeName);
		if(attr == null)
			System.out.println("no attribute found");
		else
			System.out.println("Attribute: "+attributeName+  " new Value : " + newValue +" " + attr.getName() );
		
		model.setAttributeValue(attr, newValue);
 	}
	
	@Override
	public void undo() {
		EAttribute attr = model.getAttributeByName(attributeName);
		if (attr != null )
			((EObject)model.getEObject()).eSet(attr, oldValue);
	}
	
	public void setNewValue(String newValue){
		this.newValue = newValue;
	}
	
	public void setModel(Node model, String attributeName){
		this.model = model;
		this.attributeName = attributeName;
	}

}
