package de.mdelab.instanceGraphEditor.ui.parts;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;

import de.mdelab.instanceGraphEditor.ui.model.Link;
import de.mdelab.instanceGraphEditor.ui.model.Graph;
import de.mdelab.instanceGraphEditor.ui.model.Node;
import de.mdelab.instanceGraphEditor.ui.model.SelfLink;

public class GraphEditPartFactory implements EditPartFactory {
	
	EditPart part = null;

	public EditPart createEditPart(EditPart context, Object model) {
		
		if (model instanceof Graph) {
			return new GraphEditPart((Graph) model);
		} else if (model instanceof Node) {
			return new NodesEditPart((Node) model);
		} else if (model instanceof SelfLink) {
			return new SelfLinkEditPart((SelfLink) model);
		} else if (model instanceof Link) {
			return new LinkEditPart((Link) model);
		}else {
			return null;
		}
	}
}