package de.mdelab.resourceSetSynchronizer.protocols.synchronization.indications;

import org.eclipse.net4j.signal.Indication;
import org.eclipse.net4j.signal.SignalProtocol;
import org.eclipse.net4j.util.io.ExtendedDataInputStream;

import de.mdelab.resourceSetSynchronizer.SynchronizerAdapter;
import de.mdelab.resourceSetSynchronizer.protocols.synchronization.SynchronizationProtocolMessagesEnum;

public class DisconnectClientIndication extends Indication {
	
	private final SynchronizerAdapter synchronizerAdapter;

	public DisconnectClientIndication(	final SignalProtocol<?> protocol, 
										final SynchronizerAdapter p_synchronizerAdapter ) {
		super( protocol, SynchronizationProtocolMessagesEnum.DISCONNECT_CLIENT );
		
		synchronizerAdapter = p_synchronizerAdapter;
	}

	@Override
	protected void indicating(ExtendedDataInputStream in) throws Exception {
		String adapterUUID = in.readString();

		synchronizerAdapter.disconnect(adapterUUID);
	}
}
