package de.mdelab.resourceSetSynchronizer.protocols.synchronization.requests;

import org.eclipse.net4j.signal.Request;
import org.eclipse.net4j.signal.SignalProtocol;
import org.eclipse.net4j.util.io.ExtendedDataOutputStream;

import de.mdelab.resourceSetSynchronizer.SynchronizerAdapter;
import de.mdelab.resourceSetSynchronizer.protocols.synchronization.SynchronizationProtocolMessagesEnum;

public class DisconnectClientRequest extends Request {
	
	private final SynchronizerAdapter synchronizerAdapter;

	public DisconnectClientRequest(	final SignalProtocol<?> protocol,
									final SynchronizerAdapter p_synchronizerAdapter )	{
		super( protocol, SynchronizationProtocolMessagesEnum.DISCONNECT_CLIENT );
		
		synchronizerAdapter = p_synchronizerAdapter;
	}


	@Override
	protected void requesting(ExtendedDataOutputStream out)
	throws Exception {
		out.writeString( synchronizerAdapter.getAdapterUUID() );
	}
}
