package de.mdelab.sdm.interpreter.code.debug.ui;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.debug.core.DebugException;
import org.eclipse.debug.core.DebugPlugin;
import org.eclipse.debug.core.model.DebugElement;
import org.eclipse.emf.ecore.EObject;

public abstract class SDDebugElement<StoryDiagramElement extends EObject> extends DebugElement {
	
	// DB use the field of the super class
	//private final SDDebugTarget<StoryDiagramElement, ?>	sdDebugTarget;

	public SDDebugElement( final SDDebugTarget<StoryDiagramElement, ?> p_target ) {
		super( p_target );

		//this.sdDebugTarget = target;
	}

	@Override
	public String getModelIdentifier() {
		return SDDebugUiConstants.DEBUG_MODEL_IDENTIFIER;
	}

	protected void abort(	final String p_message, 
							final Throwable p_th )
	throws DebugException {
		throw new DebugException( new Status( IStatus.ERROR, SDDebugUiPlugin.getDefault().getBundle().getSymbolicName(), DebugPlugin.INTERNAL_ERROR, p_message, p_th ) );
	}

	@SuppressWarnings("unchecked")
	@Override
	public SDDebugTarget<StoryDiagramElement, ?> getDebugTarget()	{
		return (SDDebugTarget<StoryDiagramElement, ?>) super.getDebugTarget(); //this.sdDebugTarget;
	}
}
