
package de.mdelab.sdm.interpreter.code.debug.ui.launcher.table.actparameter;

import java.util.LinkedHashMap;
import java.util.Map;

import org.eclipse.emf.ecore.util.EcoreUtil;

import de.mdelab.sdm.interpreter.code.debug.ui.launcher.table.TableData;

/**
 * Class that plays the role of the domain model
 */
public abstract class SDTableActivityParameterData<Activity, ActivityParameter extends SDTableActivityParameter<?, ?>> extends TableData<Activity, ActivityParameter>{
	
	/**
	 * Constructor
	 */
	public SDTableActivityParameterData() {
		super();
	}

	public Map<String, String> getDataString() {
		final Map<String, String> params = new LinkedHashMap<String, String>();
		
		for ( final ActivityParameter param : getRowObjects() ) {
			params.put( param.getName(), param.getInstanceObject() == null ? null : EcoreUtil.getURI( param.getInstanceObject() ).toString() );
		}
		
		return params;
	}
}
